<?php
	define( '_JEXEC', 1 );
	define('JPATH_BASE', str_replace(array('modules\mod_clima','modules\mod_clima'),'',dirname(__FILE__)) );	
	define( 'DS', DIRECTORY_SEPARATOR );
	require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
	require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );
	$mainframe =& JFactory::getApplication('site');
	$mainframe->initialise();
	$session =& JFactory::getSession();
	
	$lang = & JFactory :: getLanguage();
	$lang->load('mod_clima', JPATH_BASE);
	jimport('joomla.methods');
	
	
			/**
		 * get params
		 */
		$db	=& JFactory::getDBO();
		$sql = "SELECT params FROM #__modules WHERE module = 'mod_clima'";
		$db->setQuery( $sql );
		$p = $db->loadObjectList();		
		require_once(JPATH_BASE.DS.'libraries'.DS.'joomla'.DS.'html'.DS.'parameter.php');		
		$params = new JParameter($p[0]->params, JPATH_BASE.DS.'modules'.DS.'mod_clima'.DS.'mod_clima.xml');
		
		
	 
	 
	function curl_content($url)
    {
        if (function_exists('curl_init'))
        {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_HEADER, 0);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0');
            $content = curl_exec($ch);
            curl_close($ch);
        }
        return $content;
    }   
	/**
	 * Farenheight to Celsius conversion
	 *
	 * @param int $temperature
	 * @return int
	 */
    function f2c($temperature, $scale)
    {
    	if($scale=='f') return $temperature;
    	
    	$scale = $temperature - 32;
    	return round($scale*5/9);
    }
    
    $icon_mappings = array(
    	'sunny.gif'=>array(
    		'icon'=>''. JURI::base().'images/sunny.png',
    		'message'=>JText::_('SUNNY')),
		'mostly_sunny.gif'=>array(
			'icon'=>''. JURI::base().'images/mostly_sunny.png',
			'message'=>JText::_('MSUNNY')),
		'chance_of_storm.gif'=>array(
			'icon'=>''. JURI::base().'images/chance_of_storm.png',
			'message'=>JText::_('COSTORM')),
		'chance_of_rain.gif'=>array(
			'icon'=>''. JURI::base().'images/chance_of_rain.png',
			'message'=>JText::_('CORAIN')),
		'chance_of_snow.gif'=>array(
			'icon'=>''. JURI::base().'images/chance_of_snow.png',
			'message'=>JText::_('COSNOW')),
		'cloudy.gif'=>array(
			'icon'=>''. JURI::base().'images/cloudy.png',
			'message'=>JText::_('CLOUDY')),
		'partly_cloudy.gif'=>array(
			'icon'=>''. JURI::base().'images/partly_cloudy.png',
			'message'=>JText::_('PCLOUDY')),
		'mostly_cloudy.gif'=>array(
			'icon'=>''. JURI::base().'images/mostly_cloudy.png',
			'message'=>JText::_('MCLOUDY')),
		'mist.gif'=>array(
			'icon'=>''. JURI::base().'images/mist.png',
			'message'=>JText::_('MIST')),
		'storm.gif'=>array(
			'icon'=>''. JURI::base().'images/storm.png',
			'message'=>JText::_('STORM')),
		'thunderstorm.gif'=>array(
			'icon'=>''. JURI::base().'images/thunderstorm.png',
			'message'=>JText::_('THUNDERSTORM')),
		'sleet.gif'=>array(
			'icon'=>''. JURI::base().'images/sleet.png',
			'message'=>JText::_('SLEET')),
		'snow.gif'=>array(
			'icon'=>''. JURI::base().'images/snow.png',
			'message'=>JText::_('SNOW')),
		'icy.gif'=>array(
			'icon'=>''. JURI::base().'images/icy.png',
			'message'=>JText::_('ICY')),
		'dust.gif'=>array(
			'icon'=>''. JURI::base().'images/dust.png',
			'message'=>JText::_('DUST')),
		'fog.gif'=>array(
			'icon'=>''. JURI::base().'images/fog.png',
			'message'=>JText::_('FOG')),
		'smoke.gif'=>array(
			'icon'=>''. JURI::base().'images/smoke.png',
			'message'=>JText::_('SMOKE')),
		'haze.gif'=>array(
			'icon'=>''. JURI::base().'images/haze.png',
			'message'=>JText::_('HAZE')),
		'rain.gif'=>array(
			'icon'=>''. JURI::base().'images/rain.png',
			'message'=>JText::_('RAIN'))
    );
    $icon_small = array(
    	'sunny.gif'=>array(
    		'icon'=>''. JURI::base().'images/small/sunny.png',
    		'message'=>JText::_('SUNNY')),
		'mostly_sunny.gif'=>array(
			'icon'=>''. JURI::base().'images/small/mostly_sunny.png',
			'message'=>JText::_('MSUNNY')),
		'chance_of_storm.gif'=>array(
			'icon'=>''. JURI::base().'images/small/chance_of_storm.png',
			'message'=>JText::_('COSTORM')),
		'chance_of_rain.gif'=>array(
			'icon'=>''. JURI::base().'images/small/chance_of_rain.png',
			'message'=>JText::_('CORAIN')),
		'chance_of_snow.gif'=>array(
			'icon'=>''. JURI::base().'images/small/chance_of_snow.png',
			'message'=>JText::_('COSNOW')),
		'cloudy.gif'=>array(
			'icon'=>''. JURI::base().'images/small/cloudy.png',
			'message'=>JText::_('CLOUDY')),
		'partly_cloudy.gif'=>array(
			'icon'=>''. JURI::base().'images/small/partly_cloudy.png',
			'message'=>JText::_('PCLOUDY')),
		'mostly_cloudy.gif'=>array(
			'icon'=>''. JURI::base().'images/small/mostly_cloudy.png',
			'message'=>JText::_('MCLOUDY')),
		'mist.gif'=>array(
			'icon'=>''. JURI::base().'images/small/mist.png',
			'message'=>JText::_('MIST')),
		'storm.gif'=>array(
			'icon'=>''. JURI::base().'images/small/storm.png',
			'message'=>JText::_('STORM')),
		'thunderstorm.gif'=>array(
			'icon'=>''. JURI::base().'images/small/thunderstorm.png',
			'message'=>JText::_('THUNDERSTORM')),
		'sleet.gif'=>array(
			'icon'=>''. JURI::base().'images/small/sleet.png',
			'message'=>JText::_('SLEET')),
		'snow.gif'=>array(
			'icon'=>''. JURI::base().'images/small/snow.png',
			'message'=>JText::_('SNOW')),
		'icy.gif'=>array(
			'icon'=>''. JURI::base().'images/small/icy.png',
			'message'=>JText::_('ICY')),
		'dust.gif'=>array(
			'icon'=>''. JURI::base().'images/small/dust.png',
			'message'=>JText::_('DUST')),
		'fog.gif'=>array(
			'icon'=>''. JURI::base().'images/small/fog.png',
			'message'=>JText::_('FOG')),
		'smoke.gif'=>array(
			'icon'=>''. JURI::base().'images/small/smoke.png',
			'message'=>JText::_('SMOKE')),
		'haze.gif'=>array(
			'icon'=>''. JURI::base().'images/small/haze.png',
			'message'=>JText::_('HAZE')),
		'rain.gif'=>array(
			'icon'=>''. JURI::base().'images/small/rain.png',
			'message'=>JText::_('RAIN'))
    );
	
	$humidity = JText::_('HUMIDITY');
    $wind = JText::_('WIND');
    $days = array(
    	'Mon'=>JText::_('MONDAY'),
    	'Tue'=>JText::_('TUESDAY'),
    	'Wed'=>JText::_('WEDENSDAY'),
    	'Thu'=>JText::_('THURSDAY'),
    	'Fri'=>JText::_('FRIDAY'),
    	'Sat'=>JText::_('SATURDAY'),
    	'Sun'=>JText::_('SUNDAY')
    );
    if(isset($_POST['city']))
    {
	    $location = 'http://www.google.com/ig/api?weather='.urlencode($_POST['city']);
	    $raw_xml = curl_content($location);    
	    $xml = new SimplexmlElement($raw_xml);  
    }else {
    	$xml = false;
    }   
	$width                    = $params->get   ('width',438);
	
	$div_weather_width = $width + 1; 
	$div_inner_width = $width + 8; 
	$div_day_width = ($width-22)/4; 
	$div_today_width = $width - 10;
	$div_temp_width = $width - 10;  
	 
?>

<div id="clima_today" style="width:<?php echo $div_today_width ?>px;">
	<?php if(!$xml):?>
	<div class="error"><strong><?php echo JText::_('Error1'); ?></div>
	<?php elseif(!$xml->weather->forecast_information->city['data']):?>
	<div class="error"><strong><?php echo JText::_('Error2'); ?></div>
	<?php else:?>
	 <?php $current = $xml->weather->current_conditions;?>
     <?php
			$item2 = $xml->weather; 
			$new2 = $item2->current_conditions; 
			$ic2 = str_replace('/ig/images/weather/','',$new2->icon['data']);
	?>
    <?php if (empty($current->icon['data'])) : ?> 
    <img class="png" src="modules/mod_clima/images/info.png" alt="<?php echo JText::_('Desconocido');?>" width="48" height="48" />
    <?php else: ?>
    <img class="png" src="<?php echo $icon_mappings[str_replace('/ig/images/weather/','',$current->icon['data'])]['icon'];?>" alt="<?php echo $icon_mappings[$ic2]['message'];?>" width="48" height="48" />
	<?php endif; ?> 
	<?php $temp = $_POST['scale']=='f' ? $current->temp_f['data']:$current->temp_c['data'];?>
    
	<div class="temp">
	<span class="rojo" style="font-size:15px"><?php echo $temp;?> &deg;<?php echo $_POST['scale']=='f'?'F':'C';?></span>
		
    <span class="rojox" style="font-size:13px"> - 
		<?php if (empty($current->condition['data'])) : ?> 
        <?php echo JText::_('Desconocido');?>
        <?php else: ?>
        <?php echo $icon_mappings[$ic2]['message'];?>
        <?php endif; ?> 
        </span><br />
    <span class="azul"><?php echo str_replace('Humidity', $humidity, $current->humidity['data']);?></span><br />
    <span class="azul"><?php echo str_replace('Wind', $wind, $current->wind_condition['data']);?></span>
    </div>
</div>
<div id="weather" style="width:<?php echo $div_weather_width ?>px;">
	<div class="inner" style="width:<?php echo $div_inner_width ?>px;">
	<?php foreach ($xml->weather as $item):?>
		<?php foreach ($item->forecast_conditions as $new):?>
		<?php
			$ic = str_replace('/ig/images/weather/','',$new->icon['data']);
		?>
		<div class="day" style="width:<?php echo $div_day_width ?>px;">
			<strong><?php echo $days[((string)$new->day_of_week['data'])];?></strong>
			<?php if (empty($new->icon['data'])) : ?> 
            <img class="png" width="40" height="40" src="modules/mod_clima/images/small/info.png" alt="<?php echo JText::_('Desconocido');?>" /><br/>
			<?php else: ?>
            <img class="png" width="40" height="40" src="<?php echo $icon_small[$ic]['icon'];?>" alt="<?php echo $icon_small[$ic]['message'];?>" /><br/>
            <?php endif; ?> 
		<div class="tempb">	
			<?php echo JText::_('MAX') ?>: <span class="rojoxn"><?php echo f2c($new->high['data'], $_POST['scale']);?>&deg;<?php echo $_POST['scale']=='f'?'F':'C';?></span>		<br />
			<?php echo JText::_('MIN') ?>: <span class="azuln"><?php echo f2c($new->low['data'], $_POST['scale']);?>&deg;<?php echo $_POST['scale']=='f'?'F':'C';?></span>	
        </div>
		</div>	
		<?php endforeach;?>
	<?php endforeach;?>
	</div>
</div>
<?php endif;?>